rem tool set-up
set X264_A2POPT=
set SIZEOK=n

rem x264IvVǂݍ
:set_x264_option
if "%CRFMODE%"=="y" (
    set DEFAULT_PASS=1
    goto x264_option_setting
)
echo %PRETYPE% | findstr /i "l o">nul
if not ERRORLEVEL 1 (
    set DEFAULT_PASS=%DEFAULT_PASS_SPEED%
    goto x264_option_setting
)
echo %PRETYPE% | findstr /i "m p">nul
if not ERRORLEVEL 1 (
    set DEFAULT_PASS=%DEFAULT_PASS_BALANCE%
    goto x264_option_setting
)
echo %PRETYPE% | findstr /i "n q">nul
if not ERRORLEVEL 1 (
    set DEFAULT_PASS=%DEFAULT_PASS_QUALITY%
    goto x264_option_setting
)
if /i "%PRETYPE%"=="y" (
    set DEFAULT_PASS=1
    goto x264_option_setting
)
rem PRETYPE x 
set DEFAULT_PASS=%DEFAULT_PASS_QUALITY%
goto x264_option_setting

:x264_option_setting
call ..\setting\x264_common.bat
if /i "%PRETYPE%"=="t" (
  call ..\setting\m\%SETTING1%.bat
) else if "%PRETYPE%"=="a" (
  call ..\setting\m\%SETTING1%.bat
) else (
  call ..\setting\%PRETYPE%\%SETTING1%.bat
)
if "%COLORMATRIX%"=="BT.709" (
    set X264_COLORMATRIX=bt709
) else (
    set X264_COLORMATRIX=smpte170m
)
if "%FULL_RANGE%"=="off" (
    set RANGE=tv
) else if "%FULL_RANGE%"=="on" (
    set RANGE=pc
) else (
    set RANGE=auto
)

if /i not "%PRETYPE%"=="s" (
    if not "%X264_VFR_ENC%"=="true" (
        set MP4_FPS=-fps %FPS%
    )
)

if "%X264_VFR_ENC%"=="true" (
   set X264_TIMECODE=--tcfile-in %X264_TC_FILE%
   set TEMP_264=%TEMP_DIR%\video.mp4
   .\avs2pipemod.exe -x264rawtc=8 %VIDEO_AVS%> %TEMP_INFO%
) else (
   .\avs2pipemod.exe -x264raw=8 %VIDEO_AVS%> %TEMP_INFO%
)
for /f "delims=" %%i in (%TEMP_INFO%) do set X264_A2POPT=%%i

set X264_COMMON=--range %RANGE% -I %KEYINT% -i %MIN_KEYINT% --scenecut %SCENECUT% -b %BFRAMES% --b-adapt %B_ADAPT% --b-pyramid %B_PYRAMID% -r %REF% -B %V_BITRATE% --rc-lookahead %RC_LOOKAHEAD% --qpstep %QPSTEP% --aq-mode %AQ_MODE% --aq-strength %AQ_STRENGTH% --qcomp %QCOMP% --weightp %WEIGHTP% --me %ME% -m %SUBME% --psy-rd %PSY_RD% -t %TRELLIS% --threads %THREADS% --colormatrix %X264_COLORMATRIX% %X264_TIMECODE% %COMMON_MISC% %MISC% 

echo ^>^>%OPTION_SUCCESS%
echo;

rem ################fGR[h################
rem 264ɃGR[h
echo ^>^>%X264_ENC_START%
echo;

if "%DEFAULT_PASS%"=="0" goto auto_pass_mode
if "%DEFAULT_PASS%"=="1" goto 1_pass_mode
if "%DEFAULT_PASS%"=="2" goto 2_pass_mode
if "%DEFAULT_PASS%"=="3" goto 3_pass_mode

echo ^>^>%PASS_ERROR%
echo;
echo ^>^>%PAUSE_MESSAGE2%
pause>nul


rem pXݒ胂[h
:auto_pass_mode
echo ^>^>%PASS_ANNOUNCE1%
echo;
rem Ppass
echo ^>^>%PASS_ANNOUNCE2%
echo;
call :first_encode
rem Qpass
echo ^>^>%PASS_ANNOUNCE3%
echo;
call :second_encode
rem Rpass
if /i "%ACTYPE%"=="y" (
  set /a V_MAX_BITRATE = %P_TEMP_BITRATE% - %TEMP_M4A_BITRATE%
  set /a I_TMAX_BITRATE = %P_TEMP_BITRATE%
) else (
  set /a V_MAX_BITRATE = %I_TMAX_BITRATE% - %TEMP_M4A_BITRATE%
)
if /i "%ENCTYPE%"=="y" (
  if %E_MAX_BITRATE% LEQ %V_MAX_BITRATE% (
    set /a V_MAX_BITRATE = %E_MAX_BITRATE% - %TEMP_M4A_BITRATE%
  )
)

set /a V_BITRATE_L=%V_BITRATE% * 102 / 100

.\MediaInfo.exe --Inform=General;%%FileSize%% --LogFile=%TEMP_INFO% %TEMP_264%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set /a TEMP_264_BITRATE=%%i/(%TOTAL_TIME%/8)

(
   echo 2nd Pass BR: %TEMP_264_BITRATE% kbps
)>> %ERROR_REPORT%

if %TEMP_264_BITRATE% GTR %V_MAX_BITRATE% goto auto_third_pass

if %TEMP_264_BITRATE% LEQ %V_BITRATE_L% goto :eof

:auto_third_pass
echo ^>^>%PASS_ANNOUNCE4%
echo ^>^>%PASS_ANNOUNCE5%
echo;
echo ^>^>%PASS_ANNOUNCE6%
echo;

call :second_encode

.\MediaInfo.exe --Inform=General;%%FileSize%% --LogFile=%TEMP_INFO% %TEMP_264%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set /a TEMP_264_BITRATE=%%i/(%TOTAL_TIME%/8)

(
   echo 3rd Pass BR: %TEMP_264_BITRATE% kbps
)>> %ERROR_REPORT%

if %TEMP_264_BITRATE% LEQ %V_MAX_BITRATE% (
  goto :eof
)

.\MP4Box.exe %MP4_FPS% -add %TEMP_264%#video:delay=noct -add %TEMP_M4A% -new %TEMP_MP4%
.\MediaInfo.exe --Inform=General;%%FileSize%% --LogFile=%TEMP_INFO% %TEMP_MP4%>nul
for /f %%i in (%TEMP_INFO%) do set /a TEMP_MP4_SIZE=%%i
if %TEMP_MP4_SIZE% LEQ %MAX_FILESIZE% (
  set SIZEOK=y
  goto :eof
)

:auto_fourth_pass
echo ^>^>%PASS_ANNOUNCE4%
echo ^>^>%PASS_ANNOUNCE11%
echo;
echo ^>^>%PASS_ANNOUNCE12%
echo;

set KEEP_ERROR_REPORT=true

set /a V_BITRATE = %V_BITRATE% - (%TEMP_264_BITRATE% - %V_BITRATE%)

(
   echo 4th Pass target BR: %V_BITRATE% kbps
)>> %ERROR_REPORT%


if %V_BITRATE% LEQ 0 (
	set SIZEOK=y
	goto :eof
)

set X264_COMMON=--range %RANGE% -I %KEYINT% -i %MIN_KEYINT% --scenecut %SCENECUT% -b %BFRAMES% --b-adapt %B_ADAPT% --b-pyramid %B_PYRAMID% -r %REF% -B %V_BITRATE% --rc-lookahead %RC_LOOKAHEAD% --qpstep %QPSTEP% --aq-mode %AQ_MODE% --aq-strength %AQ_STRENGTH% --qcomp %QCOMP% --weightp %WEIGHTP% --me %ME% -m %SUBME% --psy-rd %PSY_RD% -t %TRELLIS% --threads %THREADS% --colormatrix %X264_COLORMATRIX% %X264_TIMECODE% %COMMON_MISC% %MISC% 

call :final_encode
goto :eof

rem 1pass[h
:1_pass_mode
if /i "%PRETYPE%"=="y" (
    set YOUTUBE=--crf %CRF%
    echo ^>^>%PASS_ANNOUNCE10%
    echo;
) else if /i "%CRFMODE%"=="y" (
    set YOUTUBE=--crf %CRF%
    echo ^>^>%PASS_ANNOUNCE10%
    echo;
) else (
    echo ^>^>%PASS_ANNOUNCE7%
    echo;
    echo ^>^>%PASS_ANNOUNCE2%
    echo;
)
call :abr_encode

.\MediaInfo.exe --Inform=General;%%FileSize%% --LogFile=%TEMP_INFO% %TEMP_264%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set /a TEMP_264_BITRATE=%%i/(%TOTAL_TIME%/8)

(
   echo CRF BR: %TEMP_264_BITRATE% kbps
)>> %ERROR_REPORT%

if not "%BEGINNER%"=="true" (
	if /i not "%PRETYPE%"=="y" goto :eof
)

if %TEMP_264_BITRATE% LEQ %V_BITRATE% (
    goto :eof
) else (
	echo;
    echo ^>^>%SIZE_ERROR1%
    echo ^>^>%PASS_ANNOUNCE4%
	echo;
    set YOUTUBE=
    set DEFAULT_PASS=0
    if "%BEGINNER%"=="true" (
       (echo %TEMP_264_BITRATE%)> %ENC_RECORD%
       set /a MAX_BR_RECORD=%TEMP_264_BITRATE%
       set CHANGE_AUTO_BR_LIMIT=true
       set /a V_BITRATE=1000
    )
    goto x264_option_setting
)

rem 2pass[h
:2_pass_mode
echo ^>^>%PASS_ANNOUNCE8%
echo;
rem Ppass
echo ^>^>%PASS_ANNOUNCE2%
echo;
call :first_encode
rem Qpass
echo ^>^>%PASS_ANNOUNCE3%
echo;
call :final_encode

.\MediaInfo.exe --Inform=General;%%FileSize%% --LogFile=%TEMP_INFO% %TEMP_264%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set /a TEMP_264_BITRATE=%%i/(%TOTAL_TIME%/8)

(
   echo CRF BR: %TEMP_264_BITRATE% kbps
)>> %ERROR_REPORT%

goto :eof

rem 3pass[h
:3_pass_mode
echo ^>^>%PASS_ANNOUNCE9%
echo;
rem Ppass
echo ^>^>%PASS_ANNOUNCE2%
echo;
call :first_encode
rem Qpass
echo ^>^>%PASS_ANNOUNCE3%
echo;
call :second_encode
rem Rpass
echo ^>^>%PASS_ANNOUNCE6%
echo;
call :final_encode

.\MediaInfo.exe --Inform=General;%%FileSize%% --LogFile=%TEMP_INFO% %TEMP_264%>nul
for /f "delims=" %%i in (%TEMP_INFO%) do set /a TEMP_264_BITRATE=%%i/(%TOTAL_TIME%/8)

(
   echo CRF BR: %TEMP_264_BITRATE% kbps
)>> %ERROR_REPORT%

goto :eof

:abr_encode
if not "%XARCH%"=="64bit" (
  .\%X264EXE% -o %TEMP_264% %X264_COMMON% %VIDEO_AVS% %YOUTUBE% 
) else (
  .\avs2pipemod.exe -rawvideo %VIDEO_AVS% | .\%X264EXE% %X264_A2POPT% -o %TEMP_264% %X264_COMMON% %YOUTUBE%
)
echo;
exit /b
:first_encode
if not "%XARCH%"=="64bit" (
  .\%X264EXE% -p 1 -o "nul" %X264_COMMON% %VIDEO_AVS%
) else (
  .\avs2pipemod.exe -rawvideo %VIDEO_AVS% | .\%X264EXE% %X264_A2POPT% -p 1 -o "nul" %X264_COMMON%
)
echo;
exit /b
:second_encode
if not "%XARCH%"=="64bit" (
  .\%X264EXE% -p 3 -o %TEMP_264% %X264_COMMON% %VIDEO_AVS%
) else (
  .\avs2pipemod.exe -rawvideo %VIDEO_AVS% | .\%X264EXE% %X264_A2POPT% -p 3 -o %TEMP_264% %X264_COMMON%
)
echo;
exit /b
:final_encode
if not "%XARCH%"=="64bit" (
  .\%X264EXE% -p 2 -o %TEMP_264% %X264_COMMON% %VIDEO_AVS%
) else (
  .\avs2pipemod.exe -rawvideo %VIDEO_AVS% | .\%X264EXE% %X264_A2POPT% -p 2 -o %TEMP_264% %X264_COMMON%
)
echo;
exit /b
